//Variables
var SkypeObject;

var NumberOfPages;
var CurrentPage;
var SelectedItemName;

var CommunicationOK;
var WrapperOK;

var HideOfflineContacts;
var HideCallForward;
var HideSkypeOut;

var HideCallPhone;

var ContactListArray;

var StartChatByDefault;

var listSize;

function Init(){
    System.Gadget.settingsUI = "settings.html";
    LoadSettings();
    System.Gadget.onSettingsClosed = SettingsClosed;
    CurrentPage=0;
    NumberOfPages=0;
    SelectedItemName="";
    CommunicationOK=false;
    ContactListArray=new Array();
    CreateListDivs();
    var root=document.getElementById("CallPhone");
    for(i=0;i<12;i++){
        newdiv=document.createElement("div");
        newdiv.setAttribute("id","PhoneCallButton"+i);
        newdiv.setAttribute("className","CallPhone");
        newdiv.style.left=2+(i%3)*37;
        newdiv.style.top=30+Math.round(i/3-0.34)*27;
        newdiv.style.cursor="pointer";
        var buttontext=(i+1)+"";
        if (i==9) buttontext="*";
        if (i==10) buttontext="0";
        if (i==11) buttontext="#"
        newdiv.innerHTML="<span id=\"x"+i+"\" class=\"CallPhone\">"+buttontext+"</span>";
        newdiv.onclick=new Function("DialButton_Click("+i+")");
        root.appendChild(newdiv);
    }
    ShowPageNumber();
}

function CreateListDivs() {
	var root=document.getElementById("ContactList");
    var divtop=0;
    for(i=1;i<=listSize;i++){
		var div = document.getElementById("ListItem"+i);
		if ( div == null )
		{
			var newdiv=document.createElement("div");
			newdiv.setAttribute("id","ListItem"+i);
			newdiv.setAttribute("className","ListItem");
			newdiv.style.top=divtop;
			newdiv.onclick=new Function("ListItem_Click("+i+")");
			newdiv.ondblclick=new Function("ListItem_DoubleClick("+i+")");
			root.appendChild(newdiv);
		}
		divtop+=14;
    }
	
	if ( listSize == 8 )
	{
		for ( i=9;i<=16;i++ )
		{
			var div = document.getElementById("ListItem"+i);
			if ( div != null )
			{
				RemoveElement(div);
			}
		}
	}
}

function RemoveElement(obj)
{
	var parent = obj.parentNode;
	
	if ( parent )
	{
		while ( parent.nodeType != 1 )
		{
			parent = parent.parentNode;
		}
		
		parent.removeChild(obj);
	}
}

//Properties
function getWrapperOK(){
    return WrapperOK;
}

//Methods
function LoadSettings() {
	HideOfflineContacts = System.Gadget.Settings.read("HideOffline");
	HideCallForward = System.Gadget.Settings.read("HideCallForward");
	HideCallPhone = System.Gadget.Settings.read("HideCallPhone");
	HideSkypeOut = System.Gadget.Settings.read("HideSkypeOut");
	if ( System.Gadget.Settings.read("UseBigList")==true )
	{
		listSize = 16;
		setActiveStyleSheet("biglist");
		document.body.style.height = 310;
		document.getElementById("Gadget").style.height = 310;
		System.Gadget.background = "../images/background-big.png";
	}
	else
	{
		listSize = 8;
		setActiveStyleSheet("default");
		document.body.style.height = 200;
		document.getElementById("Gadget").style.height = 200;
		System.Gadget.background = "../images/background.png";
	}
	
	StartChatByDefault = System.Gadget.Settings.read("StartChatByDefault");
	if (HideOfflineContacts == "") HideOfflineContacts=false;
    if (HideCallForward == "") HideCallForward=false;
    if (HideCallPhone == "") HideCallPhone=false;
    if (HideSkypeOut == "") HideSkypeOut=false;
    if (HideCallPhone){
        if (document.getElementById("ContactList").style.display=="none") 
            ShowCallPhone();
        document.getElementById("StartCall").style.left=20;
        document.getElementById("EndCall").style.left=49;
        document.getElementById("Chat").style.left=90;
        document.getElementById("Dial").style.display="none";
    }
    else{
        document.getElementById("StartCall").style.left=40;
        document.getElementById("EndCall").style.left=65;
        document.getElementById("Chat").style.left=5;
        document.getElementById("Dial").style.display="block";
        document.getElementById("Dial").style.left=100;
    }
}

function SettingsClosed(){
    LoadSettings();	
	CreateListDivs();
    PopulateContactList(true);
}

function ShowHideSkypeNotRunning(Show){
    document.getElementById("Gadget").style.display=(Show==true?"none":"block");
    document.getElementById("SkypeNotRunning").style.display=(Show==true?"block":"none");
    LoadSettings();
}
function NameToBeDisplayed(friend){
    var TextToBeDisplayed=friend.DisplayName;
    if (TextToBeDisplayed=="") TextToBeDisplayed=friend.FullName;
    if (TextToBeDisplayed=="") TextToBeDisplayed=friend.Handle;
    return TextToBeDisplayed;
}

function SelectIndex(index) {
	var Element;
	for (i=0;i<listSize;i++){
		Element=document.getElementById("ListItem"+(i+1));
		Element.style.backgroundImage="none";
		if (Element.childNodes.length==2) Element.childNodes[1].style.color="#FFF";
	}
	Element=document.getElementById("ListItem"+(index+1));
	Element.style.backgroundImage="url('images/selected.png')";
	if (Element.childNodes.length==2) Element.childNodes[1].style.color="#000";
}

function PopulateContactList(JustOnce){
    if (CommunicationOK){
        CreateContactsArray();
		
        NumberOfPages=Math.round(ContactListArray.length/listSize+0.49);
        if (CurrentPage>NumberOfPages || CurrentPage<1) CurrentPage=1;
        for (i=0;i<listSize;i++){
            var Element=document.getElementById("ListItem"+(i+1));
            if ((CurrentPage-1)*listSize+i<ContactListArray.length){
                var friend=ContactListArray[(CurrentPage-1)*listSize+i];
                var TextToBeDisplayed=NameToBeDisplayed(friend);
                if (TextToBeDisplayed==SelectedItemName) {
                    Element.style.backgroundImage="url('images/selected.png')";
                }   
                else 
                    Element.style.backgroundImage="none";
                
                var imageNumber=friend.OnlineStatus;
                if ((imageNumber==0) && (friend.IsCallForwardActive)) imageNumber=7;
                Element.innerHTML="<img class=\"ListItem\" src=\"images/status"+imageNumber+".png\"><span class=\"ListItem\">"+TextToBeDisplayed+"</span>";
                if (TextToBeDisplayed==SelectedItemName) {
                    if (Element.childNodes.length==2) Element.childNodes[1].style.color="#000";
                }
                else
                    if (Element.childNodes.length==2) Element.childNodes[1].style.color="#FFF";
            }
            else{
                Element.style.backgroundImage="none";   
                Element.innerHTML="";
            }
        }
        ShowPageNumber();
    }
    if (!JustOnce) setTimeout("PopulateContactList()",5000);
}

function WaitForSkypeToStart(){
    if (!IsSkypeRunning()){
        ShowHideSkypeNotRunning(true);
        setTimeout("WaitForSkypeToStart()",1000);
    }
    else
        AttachamentStatus();
}
function AttachamentStatus(){
    if (SkypeObject.AttachmentStatus!=0){
        CommunicationOK=false;
        if (!IsSkypeRunning()){
            WaitForSkypeToStart();
            return;
        }
        try{
            SkypeObject.Attach();
            CommunicationOK=true;
            ShowHideSkypeNotRunning(false);
        }
        catch (e){
            ShowHideSkypeNotRunning(true);
        }
    }
    setTimeout("AttachamentStatus()",100);
}


function ShowPageNumber(){
    document.getElementById("PageNumber").innerHTML="<span class=\"Pages\"><b>Page: "+CurrentPage+"/"+NumberOfPages+"</b></span>";
}

function CreateSkypeObject(){
    try{
        SkypeObject=new ActiveXObject("Skype4COM.Skype.1");
    }
    catch(e){
        WrapperOK=false;
        ShowSkype4COMNotFound();
        return;
    }
    WrapperOK=true;
}

function ShowSkype4COMNotFound(){
    document.getElementById("Gadget").style.display="none";
    document.getElementById("Skype4COMNotFound").style.display="block";
}

function AskForGadgetRestart(){
    document.getElementById("Skype4COMNotFound_Message").style.display="none";
    document.getElementById("Skype4COMNotFound_Restart").style.display="block";
}

function IsSkypeRunning(){
    return SkypeObject.Client.IsRunning
}

function CreateContactsArray(){
    if (CommunicationOK){
        ContactListArray=new Array();
        var pos=0;
        for (i=1;i<=SkypeObject.Friends.Count;i++){
            var friend=SkypeObject.Friends(i);
            if (friend.BuddyStatus==3){
                if (friend.OnlineStatus==0){
                    if (friend.IsCallForwardActive){
                        if (HideCallForward) continue;
                    }
                    else if (HideOfflineContacts) continue;
                }
                if ((friend.OnlineStatus==5) && (HideSkypeOut)) continue;
                ContactListArray[pos++]=friend;
            }
        }
		SortContactsArray();
    }
}

function SortContactsArray(array) {
	ContactListArray.sort(SortByName);
}

function SortByName(friendA, friendB) {
	var nameA = NameToBeDisplayed(friendA);
	var nameB = NameToBeDisplayed(friendB);
	nameA += "";
	nameB += "";
	
	if ( nameA == nameB )
		return 0;
	else if ( nameA > nameB )
		return 1;
	else
		return -1;
}

//Event Handlers
function ListItem_Click(index)
{
    if ((CurrentPage-1)*listSize+index<=ContactListArray.length){
		var indexClicked = (CurrentPage-1)*listSize+index-1;
		SelectIndex(index-1);
        SelectedItemName=NameToBeDisplayed(ContactListArray[(CurrentPage-1)*listSize+index-1]);
        //PopulateContactList(true);
    }
}
function ListItem_DoubleClick(index)
{
    if ((CurrentPage-1)*listSize+index<=ContactListArray.length){
		var indexClicked = (CurrentPage-1)*listSize+index-1;
		SelectIndex(index-1);
        SelectedItemName=NameToBeDisplayed(ContactListArray[(CurrentPage-1)*listSize+index-1]);
        
		if ( StartChatByDefault )
			Chat();
		else
			Call();
    }
}
function DialButton_Click(index)
{
    var txt=document.getElementById("PhoneCallButton"+index).innerText;
    document.getElementById("PhoneNumber").value+=txt;
}
function StartSkype(){
    SkypeObject.Client.Start()
}
function Chat()
{
    if (document.getElementById("ContactList").style.display!="none"){
        if (SelectedItemName!=""){
            for (i=0;i<ContactListArray.length;i++){
                if (SelectedItemName==NameToBeDisplayed(ContactListArray[i])){
                    SkypeObject.CreateChatWith(ContactListArray[i].Handle).OpenWindow();
                    break;
                }
            }
        }
    }
    else{
        var number=document.getElementById("PhoneNumber").value;
        if (number!="") {
            try{
                var chat=SkypeObject.CreateChatWith(number);
                chat.OpenWindow();
            }
            catch(e){}
        }
    }
}
function EndCall()
{
    if (document.getElementById("ContactList").style.display!="none"){
        if (SelectedItemName!=""){
            for (i=0;i<ContactListArray.length;i++){
                if (SelectedItemName==NameToBeDisplayed(ContactListArray[i])){
                    var handle=ContactListArray[i].Handle;
                    for (j=1;j<=SkypeObject.ActiveCalls.Count;j++){
                        if (SkypeObject.ActiveCalls(j).PartnerHandle==handle) SkypeObject.ActiveCalls(j).Finish();
                        break;
                    }
                }
            }
        }
    }
}
function Call()
{
    if (document.getElementById("ContactList").style.display!="none"){
        if (SelectedItemName!=""){
            for (i=0;i<ContactListArray.length;i++){
                if (SelectedItemName==NameToBeDisplayed(ContactListArray[i])){
                    SkypeObject.PlaceCall(ContactListArray[i].Handle);
                    break;
                }
            }
        }
    }
    else{
        var number=document.getElementById("PhoneNumber").value;
        if (number!="") {
            if (number.substring(0,1)!="+" && number.substring(0,2)!="00") number="+1" + number;
            try{
                SkypeObject.PlaceCall(number);
            }
            catch(e){}
        }
    }
}
function Next(){
    if (CurrentPage<NumberOfPages){
        CurrentPage++;
        ShowPageNumber();
        PopulateContactList(true);
    }
}
function Previous(){
    if (CurrentPage>1){
        CurrentPage--;
        ShowPageNumber();
        PopulateContactList(true);
    }
}
function ShowCallPhone(){
    var CLvisible=document.getElementById("ContactList").style.display;
    document.getElementById("ContactList").style.display=(CLvisible!="none"?"none":"block");
    document.getElementById("CallPhone").style.display=(CLvisible!="none"?"block":"none");
}